import threading
import math
import libtcodpy as libtcod

########
#PLAYER#
########

class Player:
     def __init__(self,name,money,inventory,pos_x, pos_y, color, char):
          self._name = name
          self._money = money
          self._moneyLock = threading.Lock()
          self._inventory = inventory
          self._pos_x = pos_x
          self._pos_y = pos_y
          self.color = color
          self.char = char

     def hasItem(self, item):
          return self._inventory.count(item)

     def hasMoney(self, money):
          _moneyLock.acquire()
          ret = self._money >= money
          _moneyLock.release()
          return ret
          
     def add_item(self, item):
          self._inventory.append(item)

     def buy():
          if self.hasMoney:
               _inventory.append(item)
               _moneyLock.acquire()
               _money -= money
               _moneyLock.release()

     def sell(self, item, money):
          if self.hasItem(item):
               _inventory.remove(item)
               _moneyLock.acquire()
               _money  += money
               _moneyLock.release()
               
     def __str__(self):
          return self._name + ' has ' + repr(self._money) + ' money.' + ' Inventory: ' + string.join(map(Mech.__str__, self._inventory))

     def name_creator():
               sur_name_list       = ['Tim','Carlos','Wulf','Leon','Kayzer','Dean','Thomas','Alexander','Andreas','Max','Norman','Sean','Sebastian','Jacob','Robert','James','Marius','Marcus','Russle','Peter','Lex','Nathanael','George','Barrack','Oliver','Daniel','William','Florian','Anthony','Frederick','Dan','Forest','Eric','Ian','Bob']
               middle_name_list    = ['A.','B.','C.','D.','E.','F.','G.','H.','I.','J.','K.','L.','M.','N.']
               family_name_list    = ['Keaton', 'Fenster', 'Kint','Finneran','Smith','Johnson','Willard','Bush','Taylor','Cash','Stevens','Barker','Scott','Mason','Price','Owen','Robinson','Thomson','Anderson','Miller','Cox','McGuiness','Gump','O\'Connel','Weingardner','Fox','Brown','White','Black','Ryan']
               return sur_name_list[libtcod.random_get_int(0,1,len(sur_name_list) - 1)] + ' ' + middle_name_list[libtcod.random_get_int(0,1,len(middle_name_list) - 1)] + ' ' + family_name_list[libtcod.random_get_int(0,1,len(family_name_list) - 1)]

     def move(self, dx, dy):
          if not squares[self.x + dx][self.y + dy].blocked:
               self.x += dx
               self.y += dy

     def move_towards(self, target_x, target_y):
          dx = target_x - self.x
          dy = target_y - self.y
          distance = math.sqrt(dx ** 2 + dy ** 2)

          dx = int(round(dx / distance))
          dy = int(round(dy / distance))
          self.move(dx, dy)

class ShopOwner(Player):
     def __init__(self,name,money):
          Player.__init__(self,name, money, [])

     def refillInventory():
          for i in range(1, 8):
               addItem(createRandomMech())


