import libtcodpy as libtcod
import mapMod
import objMod
import keyMod
import makewinMod

#########################
# WINDOW INITIALIZATION #
#########################

SCREEN_WIDTH = 80
SCREEN_HEIGHT = 50
LIMIT_FPS = 20

def example():
     global map_1
     i = 0
     j = 0
     i_maximum = 100
     j_maximum = 20
     direction = 0
     random_x = 0
     random_y = 0
     map_1 = mapMod.Map(SCREEN_WIDTH, SCREEN_HEIGHT, mapMod.Grass())

########
#FOREST#
########
     while i < 100:
          i += 1
          map_1.set_tile(libtcod.random_get_int(0,0,SCREEN_WIDTH-1), libtcod.random_get_int(0,0,SCREEN_HEIGHT-1), mapMod.Forest())
     
###########
#MOUNTAINS#
###########
     i = 0
     while j < j_maximum:
          i = 0
          j += 1
          random_x = libtcod.random_get_int(0,0,SCREEN_WIDTH-1)
          random_y = libtcod.random_get_int(0,0,SCREEN_HEIGHT-1)
          while not i > i_maximum:
               direction = libtcod.random_get_int(0, 1, 4)
               i += 1
               
               if direction == 1:
                    random_y = random_y - 1
                    if random_y < 0:
                              random_y = 0
                              
               if direction == 2:
                    random_x = random_x + 1
                    if random_x > SCREEN_WIDTH - 1:
                              random_x = SCREEN_WIDTH - 1
                              
               if direction == 3:
                    random_y = random_y + 1
                    if random_y > SCREEN_HEIGHT - 1:
                              random_y = SCREEN_HEIGHT - 1
                              
               if direction == 4:
                    random_x = random_x - 1
                    if random_x < 0:
                              random_x = 0

               if i < i_maximum/10:
                    map_1.set_tile(random_x, random_y, mapMod.Mountain_1())
               elif i < i_maximum*2/10:
                    map_1.set_tile(random_x, random_y, mapMod.Mountain_2())
               elif i < i_maximum*3/10:
                    map_1.set_tile(random_x, random_y, mapMod.Mountain_3())
               elif i < i_maximum*4/10:
                    map_1.set_tile(random_x, random_y, mapMod.Mountain_4())
               elif i < i_maximum:
                    map_1.set_tile(random_x, random_y, mapMod.Mountain_5())
#######
#WATER#
#######

     j = 0
     i_maximum = libtcod.random_get_int(0,105,105)
     while j < 20:
          random_x = libtcod.random_get_int(0,0,SCREEN_WIDTH - 1)
          random_y = libtcod.random_get_int(0,0,SCREEN_HEIGHT - 1)
          i = 0
          j +=1
          while i < 1000:
               direction = libtcod.random_get_int(0, 1, 4)
               i += 1
               
               if direction == 1:
                    random_y = random_y - 1
                    if random_y < 0:
                              random_y = 0
                              
               if direction == 2:
                    random_x = random_x + 1
                    if random_x > SCREEN_WIDTH - 1:
                              random_x = SCREEN_WIDTH - 1
                              
               if direction == 3:
                    random_y = random_y + 1
                    if random_y > SCREEN_HEIGHT - 1:
                              random_y = SCREEN_HEIGHT - 1
                              
               if direction == 4:
                    random_x = random_x - 1
                    if random_x < 0:
                              random_x = 0

               if i < i_maximum/10:
                    map_1.set_tile(random_x, random_y, mapMod.Water_1())
               elif i < i_maximum*2/10:
                    map_1.set_tile(random_x, random_y, mapMod.Water_2())
               elif i < i_maximum*3/10:
                    map_1.set_tile(random_x, random_y, mapMod.Water_3())
               elif i < i_maximum*4/10:
                    map_1.set_tile(random_x, random_y, mapMod.Water_4())
               elif i < i_maximum*5/10:
                    map_1.set_tile(random_x, random_y, mapMod.Water_5())





def window_init():
     libtcod.sys_set_fps(LIMIT_FPS)
     libtcod.console_set_custom_font('arial10x10.png',libtcod.FONT_LAYOUT_TCOD | libtcod.FONT_TYPE_GREYSCALE)
     libtcod.console_init_root(mapMod.SCREEN_WIDTH, mapMod.SCREEN_HEIGHT, 'Roboter, die sich gegenseitig zerstoeren.', False)
     libtcod.console_set_default_background(0, libtcod.darkest_grey)
     libtcod.console_set_default_foreground(0, libtcod.red)
     
     example()

     renderer = mapMod.Renderer(map_1)
     renderer.render_all(map_1)

     while not libtcod.console_is_window_closed():
          for object in map_1.objects:
               object.draw()
          libtcod.console_flush()
          for object in map_1.objects:
               object.clear()
          exit = keyMod.handle_keys()
          if exit:
               break
          
          
